
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>剑指offer学习笔记1 / iVAN</title>

    <meta name="description" content="剑指offer学习笔记1 C++的标准不允许复制构造函数传值参数.A(const A&amp; other){},如果是传值参数,把形参复制到实参会调用复制构造函数,就会形成无休止的递归调用从而导致栈溢出. 赋值运算符函数 class CMyString { public: CMyString(char *pData = NULL); CMyString(const CMyString&amp; str); ~CMyString(); CMyString&amp; operator=(const CMyString&am ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">剑指offer学习笔记1</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>C++的标准不允许复制构造函数传值参数。<code>A(const A&amp; other){}</code>，如果是传值参数，把形参复制到实参会调用复制构造函数，就会形成无休止的递归调用从而导致栈溢出。</p>
<h1>赋值运算符函数</h1>
<pre><code>class CMyString
{
public:
    CMyString(char *pData = NULL);
    CMyString(const CMyString&amp; str);
    ~CMyString();
    CMyString&amp; operator=(const CMyString&amp; other);
private:
    char *m_pData;
};

CMyString&amp; CMyString::operator=(const CMyString&amp; other)
{
    if (this == &amp;other)
    {
        return *this;
    }
    delete m_pData;
    m_pData = new char[strlen(other.m_pData) + 1];
    strcpy(m_pData, other.m_pData);
}</code></pre>
<h1>合并两个已排序数组，第一个数组足以容纳两个数组的所有元素</h1>
<pre><code>int merge(int num1[], int len1, int num2[], int len2)
{
    int i = len1 + len2 - 1;
    int j = len1 - 1;
    int k = len2 - 1;
    while (j &gt;= 0 &amp;&amp; k &gt;= 0)
    {
        if (num1[j] &gt; num1[k])
        {
            num1[i--] = num1[j--];
        }
        else
        {
            num1[i--] = num2[k--];
        }
    }
    while (j &gt;= 0)
    {
        num1[i--] = num1[j--];
    }
    while (k &gt;= 0)
    {
        num1[i--] = num2[k--];
    }

    return len1 + len2;
}</code></pre>
<h1>链表中删除某个结点</h1>
<pre><code>ListNode* deleteNode(ListNode *head, int key)
{
    if (head == NULL)
    {
        return head;
    }
    ListNode *cur = head;
    ListNode *pre;
    ListNode *temp;
    while (cur-&gt;val != key)
    {
        pre = cur;
        cur = cur-&gt;next;
    }
    temp = cur;
    if (cur == head)
    {
        head = head-&gt;next;
    }
    else
    {
        pre-&gt;next = cur-&gt;next;
    }
    delete temp;

    return head;
}</code></pre>
<p>或</p>
<pre><code>ListNode* deleteNode(ListNode *head, int key)
{
    if (head == NULL)
    {
        return head;
    }
    ListNode *temp;
    if (head-&gt;val == key)
    {
        temp = head;
        head = head-&gt;next;
    }
    else
    {
        ListNode *p = head;
        while (p-&gt;next != NULL &amp;&amp; p-&gt;next-&gt;val != key)
        {
            p = p-&gt;next;
        }
        if (p-&gt;next != NULL &amp;&amp; p-&gt;next-&gt;val == key)
        {
            temp = p-&gt;next;
            p-&gt;next = p-&gt;next-&gt;next;
        }
    }
    delete temp;

    return head;
}</code></pre>
<h1>从尾到头打印链表</h1>
<pre><code>void print(ListNode *head)
{
    if (head != NULL)
    {
        print(head-&gt;next);
        cout&lt;&lt;head-&gt;val&lt;&lt;" ";
    }
}</code></pre>
<p>或</p>
<pre><code>void print(ListNode *head)
{
    stack&lt;ListNode*&gt; s;
    while (head != NULL)
    {
        s.push(head);
        head = head-&gt;next;
    }
    while (!s.empty())
    {
        cout&lt;&lt;s.top()-&gt;val&lt;&lt;" ";
        s.pop();
    }
}</code></pre>
<h1>重建二叉树</h1>
<pre><code>TreeNode* constructHelp(int *prestart, int *preend, int *instart, int *inend)
{
    int *rootin = instart;
    while (rootin &lt;= inend &amp;&amp; *rootin != *prestart)
    {
        ++rootin;
    }
    int leftLen = rootin - instart;
    int rightLen = inend - rootin;
    TreeNode *root = new TreeNode(*prestart);
    if (leftLen &gt; 0)
    {
        root-&gt;left = constructHelp(prestart + 1, prestart + leftLen, instart, rootin - 1);
    }
    if (rightLen &gt; 0)
    {
        root-&gt;right = constructHelp(prestart + leftLen + 1, preend, rootin + 1, inend);
    }

    return root;
}

TreeNode* construct(int preorder[], int inorder[], int len)
{
    if (preorder == NULL || inorder == NULL || len &lt;= 0)
    {
        return NULL;
    }
    return constructHelp(preorder, preorder + len - 1, inorder, inorder + len - 1);
}</code></pre>
<h1>两个栈实现一个队列</h1>
<pre><code>template&lt;class T&gt; class MyQueue
{
public:
    void push(T t)
    {
        s1.push(t);
    }

    void pop()
    {
        if (s2.empty())
        {
            gather(s1, s2);
        }
        s2.pop();
    }

    T front()
    {
        if (s2.empty())
        {
            gather(s1, s2);
        }
        return s2.top();
    }

    bool empty()
    {
        return s1.empty() &amp;&amp; s2.empty();
    }
private:
    void gather(stack&lt;T&gt; &amp;s1, stack&lt;T&gt; &amp;s2)
    {
        while (!s1.empty())
        {
            s2.push(s1.top());
            s1.pop();
        }
    }
    stack&lt;T&gt; s1;
    stack&lt;T&gt; s2;
};</code></pre>
<h1>两个队列实现一个栈</h1>
<pre><code>template&lt;class T&gt; class MyStack
{
public:
    void push(T t)
    {
        if (q1.empty())
        {
            q2.push(t);
        }
        else
        {
            q1.push(t);
        }
    }

    T top()
    {
        T t = leaveOne(q2, q1);
        push(t);

        return t;
    }

    void pop()
    {
        leaveOne(q1, q2);
    }

    bool empty()
    {
        return q1.empty() &amp;&amp; q2.empty();
    }
private:
    T leaveOne(queue&lt;T&gt; &amp;q1, queue&lt;T&gt; &amp;q2)
    {
        if (q1.size() == 0)
        {
            swap(q1, q2);
        }
        while (q1.size() &gt; 1)
        {
            q2.push(q1.front());
            q1.pop();
        }
        T t = q1.front();
        q1.pop();

        return t;
    }
    queue&lt;T&gt; q1;
    queue&lt;T&gt; q2;
};</code></pre>
<h1>排序员工年龄（假设age&gt;= 0 &amp;&amp; age&lt;=99）</h1>
<pre><code>void sort(int num[], int len)
{
    int cnt[100] = {0};
    for (int i = 0; i &lt; len; i++)
    {
        cnt[num[i]]++;
    }

    int index = 0;
    for (int i = 0; i &lt; 100; i++)
    {
        for (int j = 0; j &lt; cnt[i]; j++)
        {
            num[index++] = i;
        }
    }
}</code></pre>
<h1>旋转数组的最小数字</h1>
<pre><code>int findMinHelp(int num[], int left, int right)
{
    int res = left;
    for (int i = left + 1; i &lt;= right; i++)
    {
        if (num[i] &lt; num[res])
        {
            res = i;
        }
    }
    return res;
}

int findMin(int num[], int len)
{
    int left = 0;
    int right = len - 1;
    int mid = left;
    while (num[left] &gt;= num[right])
    {
        if (right - left == 1)
        {
            mid = right;
            break;
        }
        mid = (left + right) / 2;
        if (num[mid] == num[left] &amp;&amp; num[mid] == num[right])
        {
            return findMinHelp(num, left, right);
        }
        if (num[mid] &gt;= num[left])
        {
            left = mid;
        }
        else if (num[mid] &lt;= num[right])
        {
            right = mid;
        }
    }
    return mid;
}</code></pre>
<h1>三种错误处理方式优缺点比较</h1>
<h1>打印1到最大的n位数</h1>
<pre><code>void print(int num[], int len)
{
    bool flag = false;
    int index;
    for (int i = 0; i &lt; len; i++)
    {
        if (num[i] != 0)
        {
            index = i;
            flag = true;
            break;
        }
    }
    if (flag)
    {
        for (int i = index; i &lt; len; i++)
        {
            cout&lt;&lt;num[i];
        }
        cout&lt;&lt;" ";
    }
}

void fun(int num[], int len, int pos)
{
    for (int i = 0; i &lt; 10; i++)
    {
        num[pos] = i;
        if (pos == len - 1)
        {
            print(num, len);
        }
        else
        {
            fun(num, len, pos + 1);
        }
    }
}</code></pre>
<h1>在O(1)时间内删除链表结点</h1>
<pre><code>ListNode* deleteNode(ListNode *head, ListNode *del)
{
    if (head == NULL || del == NULL)
    {
        return head;
    }
    if (del-&gt;next != NULL)
    {
        ListNode *temp = del-&gt;next;
        del-&gt;val = temp-&gt;val;
        del-&gt;next = temp-&gt;next;
        delete temp;
    }
    else if (del == head)
    {
        delete head;
        head == NULL;
    }
    else
    {
        ListNode *p  = head;
        while (p-&gt;next != del)
        {
            p = p-&gt;next;
        }
        p-&gt;next = del-&gt;next;
        delete del;
    }

    return head;
}</code></pre>
<h1>调整数组顺序使奇数位于偶数前面</h1>
<pre><code>void fun(int num[], int len)
{
    if (num == NULL)
    {
        return;
    }
    int i = 0;
    int j = len - 1;
    while (i &lt; j)
    {
        while (i &lt; j &amp;&amp; num[i] &amp; 0x1)
        {
            i++;
        }
        while (i &lt; j &amp;&amp; !(num[j] &amp; 0x1))
        {
            j--;
        }
        swap(num[i++], num[j--]);
    }
}</code></pre>
<p>此处有一种扩展方法，将第二个和第三个while的判断条件写成一个函数，然后为主函数增加一个参数，该参数为一个函数指针。</p>
<h1>链表中倒数第K个结点</h1>
<pre><code>ListNode* findKth(ListNode *head, int k)
{
    if (head == NULL || k == 0)
    {
        return NULL;
    }
    ListNode *p1 = head;
    for (int i = 0; i &lt; k - 1; i++)
    {
        if (p1-&gt;next != NULL)
        {
            p1 = p1-&gt;next;
        }
        else
        {
            return NULL;
        }
    }
    ListNode *p2 = head;
    while (p1-&gt;next != NULL)
    {
        p1 = p1-&gt;next;
        p2 = p2-&gt;next;
    }

    return p2;
}</code></pre>
<h1>反转链表</h1>
<pre><code>ListNode* reverse(ListNode *head)
{
    if (head == NULL)
    {
        return head;
    }
    ListNode *pre = head;
    ListNode *cur = head-&gt;next;
    while (cur != NULL)
    {
        pre-&gt;next = cur-&gt;next;
        cur-&gt;next = head;
        head = cur;
        cur = pre-&gt;next;
    }

    return head;
}

ListNode* reverse2(ListNode *head)
{
    if (head == NULL || head-&gt;next == NULL)
    {
        return head;
    }
    ListNode *newhead = reverse2(head-&gt;next);
    head-&gt;next-&gt;next = head;
    head-&gt;next = NULL;

    return newhead;
}</code></pre>
<h1>合并两个排序的链表</h1>
<pre><code>ListNode* merge(ListNode *head1, ListNode *head2)
{
    if (head1 == NULL)
    {
        return head2;
    }
    else if (head2 == NULL)
    {
        return head1;
    }
    ListNode *head;
    if (head1-&gt;val &lt; head2-&gt;val)
    {
        head = head1;
        head1 = head1-&gt;next;
    }
    else
    {
        head = head2;
        head2 = head2-&gt;next;
    }
    ListNode *pre = head;
    while (head1 != NULL &amp;&amp; head2 != NULL)
    {
        if (head1-&gt;val &lt; head2-&gt;val)
        {
            pre-&gt;next = head1;
            head1 = head1-&gt;next;
        }
        else
        {
            pre-&gt;next = head2;
            head2 = head2-&gt;next;
        }
        pre = pre-&gt;next;
    }
    if (head1 != NULL)
    {
        pre-&gt;next = head1;
    }
    if (head2 != NULL)
    {
        pre-&gt;next = head2;
    }

    return head;
}</code></pre>
<p>或</p>
<pre><code>ListNode* merge(ListNode *head1, ListNode *head2)
{
    if (head1 == NULL)
    {
        return head2;
    }
    else if (head2 == NULL)
    {
        return head1;
    }
    ListNode *head;
    if (head1-&gt;val &lt; head2-&gt;val)
    {
        head = head1;
        head1 = head1-&gt;next;
    }
    else
    {
        head = head2;
        head2 = head2-&gt;next;
    }
    head-&gt;next = merge(head1, head2);
    return head;
}</code></pre>
<h1>链表排序</h1>
<pre><code>ListNode* sort(ListNode *head)
{
    ListNode *p = head;
    int len = 0;
    while (p != NULL)
    {
        len++;
        p = p-&gt;next;
    }

    for (int i = 0; i &lt; len - 1; i++)
    {
        p = head;
        for (int j = 0; j &lt; len - 1 - i; j++)
        {
            if (p-&gt;val &gt; p-&gt;next-&gt;val)
            {
                swap(p-&gt;val, p-&gt;next-&gt;val);
            }
            p = p-&gt;next;
        }
    }
    return head;
}</code></pre>
<h1>树的子结构</h1>
<pre><code>bool subTreeHelp(TreeNode *root1, TreeNode *root2)
{
    if (root2 == NULL)
    {
        return true;
    }
    if (root1 == NULL)
    {
        return false;
    }
    if (root1-&gt;val != root2-&gt;val)
    {
        return false;
    }

    return subTreeHelp(root1-&gt;left, root2-&gt;left) &amp;&amp;
        subTreeHelp(root1-&gt;right, root2-&gt;right);
}

bool hasSubTree(TreeNode *root1, TreeNode *root2)
{
    bool res = false;
    if (root1 != NULL &amp;&amp; root2 != NULL)
    {
        if (root1-&gt;val == root2-&gt;val)
        {
            res = subTreeHelp(root1, root2);
        }
        if (!res)
        {
            res = hasSubTree(root1-&gt;left, root2);
        }
        if (!res)
        {
            res = hasSubTree(root1-&gt;right, root2);
        }
    }

    return res;
}</code></pre>
<h1>二叉树的镜像</h1>
<pre><code>void mirror(TreeNode *root)
{
    if (root != NULL)
    {
        TreeNode *temp = root-&gt;left;
        root-&gt;left = root-&gt;right;
        root-&gt;right = temp;
        if (root-&gt;left != NULL)
        {
            mirror(root-&gt;left);
        }
        if (root-&gt;right != NULL)
        {
            mirror(root-&gt;right);
        }
    }
}</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 19:32:47</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>剑指offer学习笔记1的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baBnaNM.html" rel="bookmark">剑指offer学习笔记2</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				顺时针打印链表 void Matrix(vector&lt;vector&lt;int&gt;&gt;&amp; num, int x1, int y1, int x2, int y2) { int n = 1; while (x1 &lt;= x2 &amp;&amp; y1 &lt;= y2) { int i = x1, j = y1; for (int j = y1; j &lt;= y2; j++) { num[x1][j] = n++; //right } if (x1 &lt; x2) { f			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKwD6p.html" rel="bookmark">剑指offer：顺时针打印矩阵</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				剑指offer上的第20题,九度OJ上测试通过. 题目描述: 输入一个矩阵,按照从外向里以顺时针的顺序依次打印出每一个数字,例如,如果输入如下矩阵: 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 则依次打印出数字1,2,3,4,8,12,16,15,14,13,9,5,6,7,11,10. 输入: 输入可能包含多个测试样例,对于每个测试案例, 输入的第一行包括两个整数m和n(1&lt;=m,n&lt;=1000):表示矩阵的维数为m行n列. 返回栏目页:http://www			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgR76b.html" rel="bookmark">&lbrack;剑指Offer&rsqb;5&period;二维数组中的查找</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目 在一个二维数组中,每一行都按照从左到右递增的顺序排序,每一列都按照从上到下递增的顺序排序.请完成一个函数,输入这样的一个二维数组和一个整数,判断数组中是否含有该整数. 思路 [算法系列之三十三]杨氏矩阵 代码 /*--------------------------------------- * 日期:2015-07-19 * 作者:SJF0115 * 题目: 5.二维数组中的查找 * 网址:http://www.nowcoder.com/books/coding-interviews/a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwlR7mb.html" rel="bookmark">剑指offer之字符串转整数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目描述: 将一个字符串转换成一个整数,要求不能使用字符串转换整数的库函数. 输入: 输入可能包含多个测试样例. 对于每个测试案例,输入为一个合法或者非法的字符串,代表一个整数n(1&lt;= n&lt;=10000000). 输出: 对应每个测试案例, 若输入为一个合法的字符串(即代表一个整数),则输出这个整数. 若输入为一个非法的字符串,则输出&quot;My God&quot;. 样例输入:5-5+8样例输出:5-58    关于这道题目,题目本身还是不错的,真正核心的代码也就那么两行,大部分代码基			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7kR6dz.html" rel="bookmark">剑指offer之和为定值的两个数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目描述: 输入一个递增排序的数组和一个数字S,在数组中查找两个数,是的他们的和正好是S,如果有多对数字的和等于S,输出两个数的乘积最小的. 输入: 每个测试案例包括两行: 第一行包含一个整数n和k,n表示数组中的元素个数,k表示两数之和.其中1 &lt;= n &lt;= 10^6,k为int 第二行包含n个整数,每个数组均为int类型. 输出: 对应每个测试案例,输出两个数,小的先输出.如果找不到,则输出&quot;-1 -1&quot; 样例输入: 6 15 1 2 4 7 11 15 样例输出:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Myr4mlp.html" rel="bookmark">剑指offer：包含min函数的栈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				剑指offer上的第21题,之前在Cracking the Coding interview上做过,思路参考这里,这次写了测试函数,在九度OJ上测试通过. 题目描述: 定义栈的数据结构,请在该类型中实现一个能够得到栈最小元素的min函数. 输入: 输入可能包含多个测试样例,输入以EOF结束. 对于每个测试案例,输入的第一行为一个整数n(1&lt;=n&lt;=1000000), n代表将要输入的操作的步骤数. 接下来有n行,每行开始有一个字母Ci. Ci='s'时,接下有一个数字k,代表将k压入栈. Ci			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvKRlrp.html" rel="bookmark">剑指offer：栈的压入弹出序列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				剑指offer上的第22题,九度OJ上AC. 题目描述: 输入两个整数序列,第一个序列表示栈的压入顺序,请判断第二个序列是否为该栈的弹出顺序.假设压入栈的所有数字均不相等.例如序列1,2,3,4,5是某栈的压入顺序,序列4,5,3,2,1是该压栈序列对应的一个弹出序列,但4,3,5,1,2就不可能是该压栈序列的弹出序列. 输入: 每个测试案例包括3行: 第一行为1个整数n(1&lt;=n&lt;=100000),表示序列的长度. 第二行包含n个整数,表示栈的压入顺序. 第三行包含n个整数,表示栈的弹出顺序			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnYerOM.html" rel="bookmark">剑指offer系列之二十六：输出字符串的全排列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目描述 输入一个字符串,按字典序打印出该字符串中字符的所有排列.例如输入字符串abc,则打印出由字符a,b,c所能排列出来的所有字符串abc,acb,bac,bca,cab和cba. 结果请按字母顺序输出. 输入描述: 输入一个字符串,长度不超过9(可能有字符重复),字符只包括大小写字母. 此题与剑指offer原题存在一些初入,在原题中并没有规定字符串中字符是否有重复的出现.不过思路是一致的,只不过是添加额外的判断罢了.下面说说我的思路吧:先不考虑是否出现重读字符,要对一个字符进行全排列,可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYROdlp.html" rel="bookmark">&lbrack;剑指Offer&rsqb;7&period;从尾到头打印链表</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目1511:从尾到头打印链表 时间限制:1 秒 内存限制:128 兆 特殊判题:否 提交:1082 解决:350 题目描述: 输入一个链表,从尾到头打印链表每个节点的值. 输入: 每个输入文件仅包含一组测试样例. 每一组测试案例包含多行,每行一个大于0的整数,代表一个链表的节点.第一行是链表第一个节点的值,依次类推.当输入到-1时代表链表输入完毕.-1本身不属于链表. 输出: 对应每个测试案例,以从尾到头的顺序输出链表每个节点的值,每个值占一行. 样例输入: 1 2 3 4 5 -1 样例输出			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwqlOM.html" rel="bookmark" class="title">ASP生成静态Html文件的技术总结</a>
					<div>
						把HTML代码写入到文件中然后生成.html格式的文件 把HTML代码写入到文件中然后生成.html格式的文件          &lt;% filename=&quot;test.htm&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b2XgQp.html" rel="bookmark" class="title">原创内容的判断  搜索引擎的盲区</a>
					<div>
						8月10日,百度站长门诊开放日,很多站长提到了网站原创内容被百度判定为转载,而把转载网站判定为原创的问题,而且lee也表示近期将会对网站原创内容的识别改进算法.详情见:8月10日百度站长门诊开放日问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w0q1p.html" rel="bookmark" class="title">Windows Update自动更新的5种方式</a>
					<div>
						Windows Update是我们用来升级系统的组件,通过它来更新我们的系统,能够扩展系统的功能,让系统支持更多的软.硬件,解决各种兼容性问题,让系统更安全.更稳定.今天,我们就来分析一下因种种原因导 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOBGaM.html" rel="bookmark" class="title">如何设置Word 2013的默认文档作者</a>
					<div>
						为了便于管理Word文档,用户可以通过设置Word2013文档默认作者,为Word文档自动填写&quot;作者&quot;属性.在Word2013中设置默认的Word文档作者的步骤如下所述: 第1步, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk27g7M.html" rel="bookmark" class="title">Outlook Cannot create file：Outlook不能创建文件问题</a>
					<div>
						症状:用户写邮件要添加一份附件时,提示: Cannot create file:file name.Right-click the folder you want to create the file ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w1NNp.html" rel="bookmark" class="title">WSS3SDK之Feature架构介绍-Feature&period;xml文件</a>
					<div>
						Feature.xml文件 在一个 Feature.xml 文件中, Feature元素定义了其本身,并指定了相关的DLL组件,文件等的位置,或是一些用于支持该Feature的属性. Feature  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6EvBz.html" rel="bookmark" class="title">Visual C&num; 3&period;0新特性概览</a>
					<div>
						在发布Visual Studio 2005和C#2.0之后,微软公司又马不停蹄的展示了人们所期望的C#的下一代版本:C# 3.0.尽管C# 3.0并没有标准化,微软还是在PDC(专业程序员会议)发布了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4jGAp.html" rel="bookmark" class="title">JDK1&period;6集合类UML图， 更好的使用Collection类</a>
					<div>
						JDK1.6 集合类 UML 图, 更好的使用Collection类. Sets: Lists (no need Vector) Map: Queues:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKVG6p.html" rel="bookmark" class="title">AVG 2012 新版全面测试，功能改进不容错过</a>
					<div>
						随着AVG杀毒 2012 beta版的测试持续进行,笔者也逐渐了解了这款功能强大的杀毒软件.近期,AVG发布了AVG杀毒2012,相比AVG2011而言,新版程序运行速度更快了,扫描和查杀时间也缩短了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKZJWp.html" rel="bookmark" class="title">搜狗高速浏览器的网速保护有什么特点</a>
					<div>
						主动性:网速保护功能只在用户主动访问网页的时刻按需生效; 智能性:网速保护功能会智能调节分配您的网速,在生效时,下载工具或网络视频软件的上传下载速度会经过短暂的下降以满足打开网页需要的网速; 当您的网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1gQjz.html" rel="bookmark" class="title">Win7虚拟机VMware怎么完全卸载干净</a>
					<div>
						  一.虚拟机VMware怎么完全卸载干净,如何彻底卸载VMware虚拟机--禁用VM虚拟机服务. 1.首先,需要停止虚拟机VMware相关服务.按下快捷键WIN+R,打开windows运行对话框,输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwQqYb.html" rel="bookmark" class="title">在Word2010中删除样式的技巧</a>
					<div>
						  Word2010总的说来,还是比之前的版本,功能更加强大,里面有新增&quot;样式检查器&quot;功能,这个功能可以帮助用户轻松的删除文档中所使用的样式. 第1步,打开Word2010文档窗口 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24VLvp.html" rel="bookmark" class="title">网易UU加速器常见错误码原因及解决方法</a>
					<div>
						以下是大家在使用UU时比较常见的错误码和解决方法,为了能够更快地解决问题,大家遇到错误码时请先检查一下本地的系统配置,比如系统时间是否准确.网络的连接.防火墙配置.安全软件的部署.后台是否有占用带宽的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7Nd7M.html" rel="bookmark" class="title">驱动人生6怎么用</a>
					<div>
						  最新版本的驱动人生6,提供32位和64位的 XP/2003/Vista/2008/Win7/Win8/Win8.1/Win10操作系统下的智能检测及驱动程序修复.升级.备份功能.首先,搜索下载最新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8vwqp.html" rel="bookmark" class="title">QQ邮箱代收Gmail邮件教程分享</a>
					<div>
						  首先要下载安装手机QQ邮箱客户端,进入之后在添加账户中选择Gmail; 然后会跳出Google的授权信息,登陆谷歌账户; 然后选择QQ邮箱申请的授权访问Google,这样就可以了. 这个几乎和Gm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrEkAM.html" rel="bookmark" class="title">用简单的方法使控件显示变量值的变化</a>
					<div>
						问题描述 大家好,我是C#的初学者,我之前一直搞的是C++.我有个问题想问一下大家.有一个变量,这个变量的值会发生变化,但是什么时候变化,多久变一次,不知道.在界面上,我想用Lable或者Text控件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVjD5b.html" rel="bookmark" class="title">virtual-C&plus;&plus; 求解在虚继承情况下类的大小</a>
					<div>
						问题描述 C++ 求解在虚继承情况下类的大小 (1) #include using namespace std; class CommonBase { int co; //virtual void f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWGlWp.html" rel="bookmark" class="title">c&num;-C&num; 制作自定义打包程序的问题</a>
					<div>
						问题描述 C# 制作自定义打包程序的问题 我想根据客户的选择来决定安装什么文件,这样的安装程序怎么制作 解决方案 C# winform 安装程序打包(自定义操作) 解决方案二: 谢谢,但这不是我想要的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP0Xrp.html" rel="bookmark" class="title">如何在局域网内部署服务器监控 &quest;</a>
					<div>
						背景 随着互联网的发展,各种网络攻击手段也层出不穷,不管是大型企业还是中小企业,随时都有被攻击的危险,因此很多公司都会采取各种手段来维护自己服务器安全,其中比较常见的是采用内网环境,只设置一台代理服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXKXWz.html" rel="bookmark" class="title">HotSpot SA &num;2：ClassDump</a>
					<div>
						今天继续介绍HotSpot SA中的另一个好玩的工具,ClassDump.ClassDump可以在运行时dump类文件,我们可以用来dump一些动态生成或者运行时被修改了字节码的类.下面就借助Clas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RyWVb.html" rel="bookmark" class="title">mapx Feature位置问题</a>
					<div>
						问题描述 问个问题我用mapx新建一个层在新建的层上新建了一个Feature不管如何定义他的XY坐标他的位置只能定位到左上角一定的区域,不能到右下区域中去,请问是怎么回事,则么解决新增层map1.La ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AAGPz.html" rel="bookmark" class="title">How to restore ASM based OCR after complete loss of the CRS diskgroup on Linux&sol;Unix systems &lbrack;ID 1062</a>
					<div>
						  How to restore ASM based OCR after complete loss of the CRS diskgroup on Linux/Unix systems [ID 10 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZyrOM.html" rel="bookmark" class="title">js弹出窗口，可判断是否弹出代码</a>
					<div>
						//普通窗口 function openWindow(dialogName, pageUrl, width, height,  resizable) {  try {   screenWidth =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEqyEM.html" rel="bookmark" class="title">质疑江南春对分众&OpenCurlyDoubleQuote;短信门&rdquo;的回应</a>
					<div>
						2006年3月15日,我在博客上写的文章:http://www.aliyun.com/zixun/aggregation/2447.html&quot;&gt;3000万美元收购一家短信群发公司?,两 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgO75M.html" rel="bookmark" class="title">多少人没熬过45-55这段危险期&quest; 为家人&comma; 请多看一眼！</a>
					<div>
						一般来说,45-55岁应该是人生黄金年龄段之一.值得关注的是,这个时期也是生命&quot;高危期&quot;(也称疾病爆发期).据有关专家研究,人的生命线大致可分为几个阶段: A. 0-35岁为人生最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNDaeM.html" rel="bookmark" class="title">php制作文本式留言板&lowbar;php实例</a>
					<div>
						代码很简单,就不多废话了,直接奉上代码: del.php 复制代码 代码如下: &lt;html&gt; &lt;head &gt; &lt;meta charset=&quot;utf-8&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7YdYz.html" rel="bookmark" class="title">SD卡写入错误</a>
					<div>
						问题描述 写了一个SD卡扇区读写的程序,但是只有读可以用,写入无法使用.不知道为什么,请大家帮忙看看///&lt;summary&gt;///读取扇区(单个扇区)///&lt;/summary&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBN4qz.html" rel="bookmark" class="title">如何按拼音排序 - 数据库本土化特性&lpar;collate&comma; ctype&comma; &period;&period;&period;&rpar;</a>
					<div>
						标签 PostgreSQL , 按拼音排序 , collate 背景 数据库为了支持国际化,通常会涉及到collate, ctype的概念. 初始化数据库集群时,可以设置如下参数,用于设置数据库的字符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEDL8z.html" rel="bookmark" class="title">分享一个自己动手写的jQuery分页插件&lowbar;jquery</a>
					<div>
						工作需要一个JS分页插件,心想自己动手写一个吧,一来上网找一个不清楚代码结构的,出了问题难以解决,而且网上的插件所包含的功能太多,有些根本用不到,就没必要加载那段JS,二来想起没写过jQuery插件, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Zewvb.html" rel="bookmark" class="title">如何用SendMessage API让修改的系统环境变量立即生效&comma;在线等&excl;&excl;&excl;</a>
					<div>
						问题描述 [DllImport(&quot;Kernel32.DLL&quot;,SetLastError=true)]publicstaticexternboolSetEnvironmentVari ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
